<?php
/*
 * The aim of this test was to see whether it was faster to convert 0.34951000
 * to 34951000 by multiplying by 100000000 or using substr. The result was very
 * interesting.
 * 
 */
define('BENCHMARK_NUM_LOOPS', 5);
require_once 'Benchmark/Timer.php';
$timer =& new Benchmark_Timer();
$timer->start();

$image_type = 'jpg';
list($image_microtime, $image_time) = explode(' ', microtime());
#print $image_microtime . "\n";
$timer->setMarker('Start Multiplier');
for($i = 0; $i < BENCHMARK_NUM_LOOPS; $i++){
    $image_file = $image_time . '.' . ($image_microtime * 100000000) . '.' . strtolower($image_type);
} // for

$timer->setMarker('End Multiplier');
#print $image_file . "\n" . $image_microtime * 100000000 . "\n" . $image_time . "\n\n";

$timer->setMarker('Start String functions');
for($i = 0; $i < BENCHMARK_NUM_LOOPS; $i++){
    $image_file = $image_time . '.' . substr($image_microtime, 2) . '.' . strtolower($image_type);
} // for
$timer->setMarker('End String functions');
#print $image_file . "\n" . substr($image_microtime, 2) . "\n" . $image_time;

$timer->setMarker('Start String functions1');
for($i = 0; $i < BENCHMARK_NUM_LOOPS; $i++){
    $image_file = $image_time . substr($image_microtime, 1) . '.' . strtolower($image_type);
} // for
$timer->setMarker('End String functions1');
#print $image_file . "\n" . substr($image_microtime, 1) . "\n" . $image_time;

$timer->stop();
$timer->display();
?>