<?php
/*
 * This test was written when I wanted to remove comments from a text file, and
 * wondered what the most efficient way of doing it would be.  The source used
 * is small - but I will test it with a larger input sometime.
 * 
 * One limitation is that there can be no whitespace in front of the # in the
 * comment - otherwise to fully remove the line you do need a regular
 * expression.  Unless I change the processing script to work with lines full
 * of empty spaces :-)
 * 
 */
define('BENCHMARK_NUM_LOOPS', 10000);
require_once 'Benchmark/Timer.php';
$timer =& new Benchmark_Timer();

$fp = ":-)	<img src=images/emoticons/smile.gif width=15 height=15 border=0 alt=:-)>
#;-)	<img src=images/emoticons/wink.gif width=15 height=15 border=0 alt=;-)>
:-D	<img src=images/emoticons/biggrin.gif width=15 height=15 border=0 alt=:-D>
:LOL:	<img src=images/emoticons/lol.gif width=15 height=15 border=0 alt=:LOL:>
:-O	<img src=images/emoticons/eek.gif width=15 height=15 border=0 alt=:-O>
:-(	<img src=images/emoticons/cry.gif width=21 height=16 border=0 alt=:-(>
:-X	<img src=images/emoticons/mad.gif width=15 height=15 border=0 alt=:-X>
:thumbs:	<img src=images/emoticons/xyxthumbs.gif width=25 height=18 border=0 alt=:thumbs:>
:!:	<img src=images/emoticons/warning.gif width=15 height=15 border=0 alt=:!:>
# :thumbup:	<img src=images/emoticons/good.gif width=15 height=15 border=0 alt=:thumbsup:>
:thumbdown:	<img src=images/emoticons/bad.gif width=15 height=15 border=0 alt=:thumbsdown:>";
$fp = explode("\n", $fp);

$timer->start();
$timer->setMarker('Start substr');
for($x = 0; $x < BENCHMARK_NUM_LOOPS; $x++){
	for($i=0, $j = count($fp); $i < $j; $i++) {
		if (substr($fp[$i], 0, 1) != '#') {
		    // Success
		}
	}
} // for
$timer->setMarker('End substr');

$timer->setMarker('Start strpos');
for($x = 0; $x < BENCHMARK_NUM_LOOPS; $x++){
	for($i=0, $j = count($fp); $i < $j; $i++) {
		if (strpos($fp[$i], '#') != 1) {
		    // Success
		}
	}
} // for
$timer->setMarker('End strpos');

$timer->setMarker('Start preg_replace');
for($x = 0; $x < BENCHMARK_NUM_LOOPS; $x++){
    preg_replace('!^\s*#!', '', $fp);
	for($i=0, $j = count($fp); $i < $j; $i++) {

	}
} // for
$timer->setMarker('End preg_replace');

$timer->setMarker('Start preg');
for($x = 0; $x < BENCHMARK_NUM_LOOPS; $x++){
	for($i=0, $j = count($fp); $i < $j; $i++) {
        if (!preg_match('!^\s*#!',$fp[$i])) {
            
        }
	}
} // for
$timer->setMarker('End preg');

$timer->setMarker('Start preg with modifier S');
for($x = 0; $x < BENCHMARK_NUM_LOOPS; $x++){
	for($i=0, $j = count($fp); $i < $j; $i++) {
        if (!preg_match('!^\s*#!',$fp[$i])) {
            
        }
	}
} // for
$timer->setMarker('End preg with modifier S');
$timer->stop();
$timer->display();
?>